      subroutine pplotex(a,b)
c
c plotex routine generating postscript by default but can generate 
c screen output if HAS_DRIVER is defined during compilation and 
c if lgs=.true. 
c
      character*(*) a  ! filename of output postscript file (default:POST)
      character*(*) b  ! not used but or for backward compatibilty still present
      character*(*) symb ! symbol to plot
      character*(*) font ! font type (default:Times) 
      real xc(*)         ! x data array 
      real yc(*)         ! y data array
      integer n          ! number of data points
      integer nc         ! number of data points
      integer jtyp       ! linetype to use in this call
      real hgt           ! height of text to plot
      real x             ! x position in cm from from left 
      real y             ! y position in cm from from bottom
      real ang           ! angle to rotate string 
      integer nsymb      ! number of characters to plot in symb
      integer ncol       ! color number for shading
      integer nshade     ! shading style
      integer ithick     ! new line thickness 
      integer icolor     ! new color for lines and text
      real x1            ! x start point [cm]
      real y1            ! y start point [cm]
      real x2            ! x end point [cm]
      real y2            ! y end point [cm]
      integer ihold          
      integer linold
#ifndef HAS_DRIVER
       character*200 cmd
#endif 
#include "compost.inc"
      save ihold,linold
      external lenword_h
      isx(z)=nint((900./7.5)*z)  ! xscale between cm and inch*1000
      isy(z)=nint((900./7.5)*z)  ! yscale between cm and inch*1000
      ifs(z)=nint(240*z)         ! font scale
      data ihold /0/
      data lsave /.false./
      data lgs  /.false./
      data lpost /.true./
      data lu/9/
      data lw,lc /1,1/
      data lenfon /5/
      data curfont /'Times'/
#include "colortab.inc"
#ifdef HAS_DRIVER
      if ( lgs ) call splotex(a,b)
      if ( .not.lpost ) return
#endif 
c 
c open postscript file
c
      nn=len(a)
      call freeunit(lu)
      if ( nn.gt.1.and.nn.le.48) then
          psfile=a
      else
          psfile='POST'
      endif
      open(lu,file=psfile,status='unknown')
      write(lu,'(a4)') '%!PS'
      write(lu,'(a)') '/initgraphics'
      write(lu,'(a)') '/Color  true  def'
      write(lu,'(a)') 
     +  '    0    0 translate  0.25  0.25 scale /stp  8 def'
      write(lu,'(a)') '/q {quit} def'
      write(lu,'(3a)')'/r {(',psfile(1:index(psfile,' ')-1),') run} def'
C% select linetype or full color line
      write(lu,'(a)') '/c {'
      write(lu,'(a)') '      Color'
      write(lu,'(a)') '      { setrgbcolor [] 0 setdash pop}'
      write(lu,'(a)') '      { pop pop pop 0 setdash }'
      write(lu,'(a)') '      ifelse'
      write(lu,'(a)') '   } def'
C% select color or gray shading
      write(lu,'(3a)') '/g { Color {setrgbcolor pop }',
     + ' { pop pop pop 1 sub 16 mod 16 div setgray }',
     + ' ifelse } def'
C% Font Times
C% non rotated 
      write(lu,'(2a)') '/FontTimes { /Times-Roman findfont ',
     + 'sf scalefont setfont moveto show } def'
C% rotated 
      write(lu,'(a)') '/m1 { sub } def'
      write(lu,'(a)') '/m { 0 m1 } def'
      write(lu,'(a)') 
     + '/S { 3 copy m 3 1 roll m 3 1 roll m 7 3 roll s } def'
      write(lu,'(a)') 
     + '/FontTimesR {/Times-Roman findfont sf scalefont setfont'
      write(lu,'(a)') 
     +  ' translate rotate  0 0 FontTimes rotate translate } def'
      write(lu,'(a)') '/L {lineto} def'
      write(lu,'(a)') '/M {moveto} def'
C% Font Helvetica
C% non rotated 
      write(lu,'(2a)') '/FontHelvetica { /Helvetica findfont ',
     + 'sf scalefont setfont moveto show } def'
C% rotated 
      write(lu,'(a)') '/m1 { sub } def'
      write(lu,'(a)') '/m { 0 m1 } def'
      write(lu,'(a)') 
     + '/S { 3 copy m 3 1 roll m 3 1 roll m 7 3 roll s } def'
      write(lu,'(a)') 
     +  '/FontHelveticaR {/Helvetica findfont sf scalefont setfont'
      write(lu,'(a)') 
     +  ' translate rotate  0 0 FontHelvetica rotate translate } def'
      write(lu,'(a)') '/L {lineto} def'
      write(lu,'(a)') '/M {moveto} def'
C% Font Garamond
C% non rotated
      write(lu,'(2a)') '/FontGaramond { /Garamond findfont ',
     + 'sf scalefont setfont moveto show } def'
C% rotated
      write(lu,'(a)') '/m1 { sub } def'
      write(lu,'(a)') '/m { 0 m1 } def'
      write(lu,'(a)')
     + '/S { 3 copy m 3 1 roll m 3 1 roll m 7 3 roll s } def'
      write(lu,'(a)')
     + '/FontGaramondR {/Garamond findfont sf scalefont setfont'
      write(lu,'(a)')
     +  ' translate rotate  0 0 FontGaramond rotate translate } def'
      write(lu,'(a)') '/L {lineto} def'
      write(lu,'(a)') '/M {moveto} def'
C% Font Symbol
C% non rotated 
      write(lu,'(2a)') '/FontSymbol { /Symbol findfont ',
     + 'sf scalefont setfont moveto show } def'
C% rotated 
      write(lu,'(a)') '/m1 { sub } def'
      write(lu,'(a)') '/m { 0 m1 } def'
      write(lu,'(a)') 
     + '/S { 3 copy m 3 1 roll m 3 1 roll m 7 3 roll s } def'
      write(lu,'(a)') 
     + '/FontSymbolR {/Symbol findfont sf scalefont setfont'
      write(lu,'(a)') 
     +  ' translate rotate  0 0 FontSymbol rotate translate } def'
      write(lu,'(a)') '/L {lineto} def'
      write(lu,'(a)') '/M {moveto} def'
C%  line
      write(lu,'(a)') '/l {newpath moveto lineto stroke } def'
C% hashing
      write(lu,'(a)') '/h { fill  setlinewidth 1 setgray '
      write(lu,'(a)') '/pos ymin def'
      write(lu,'(a)') '/step step stp mul def'
      write(lu,'(a)') 'ymin step ymax { newpath '
      write(lu,'(a)') '/pos pos step add def '
      write(lu,'(a)') 'xmin pos moveto xmax pos lineto stroke } for '
      write(lu,'(a)') '   } def '
      write(lu,'(a)') '/v { fill  setlinewidth 1 setgray '
      write(lu,'(a)') '/pos xmin def'
      write(lu,'(a)') '/step step stp mul def'
      write(lu,'(a)') 'xmin step xmax { newpath '
      write(lu,'(a)') '/pos pos step add def'
      write(lu,'(a)') 'pos ymin moveto pos ymax lineto stroke } for'
      write(lu,'(a)') '   } def '
      write(lu,'(a)') '/h1 { 4 h } def'
      write(lu,'(a)') '/h2 { 7 h } def'
      write(lu,'(a)') '/h3 { 4 v } def'
      write(lu,'(a)') '/h4 { 7 v } def'

C% linetypes
      write(lu,'(a)') '/l1 [       ] def'
      write(lu,'(a)') '/l2 [ 20 10 20 10 ] def'
      write(lu,'(a)') '/l3 [ 8 10 8 10   ] def'
      write(lu,'(a)') '/l4 [ 5 5 5 5 ] def'
      write(lu,'(a)') '/l5 [ 15 7 5 7   ] def'
      write(lu,'(a)') '/l6 [ 10 5 10 5 ] def'
      write(lu,'(a)') '/l7 [ 5 15 5 15  ] def'
      write(lu,'(a)') '/T  { 0 setdash } def'
c 
      do i=1,6
              write(lu,'(a2,i1,a4,i1,a8)') 
     +               '/t',i,' { l',i,' T } def'
      enddo
c
c% colors
c      
      do i=1,mcol
      write(lu,'(a2,i2.2,a4,a16,a6)')
     +             '/C',i,' { ',col(i),' } def'
      enddo
c
c% select color line or monochrome line ( 1 in l1 has to be mod(l1,MLINE)+1)
c
      do i=1,mcol
            write(lu,'(a2,i2.2,a4,i1,a2,i2.2,a8)') '/c',i,
     +            ' { l',mod(i-1,6)+1,' C',i,' c } def'
      enddo
c
c% select color or gray scale ( 1 should be mod(1-1,mcol)+1)
c
      do i=1,mcol
            write(lu,'(a2,i2.2,a4,i2,a2,i2.2,a8)') '/g',i,' {  ',
     +                   mod(i-1,mcol)+1,' C',i,' g } def'
      enddo
      write(lu,'(a)') '0.1 setlinewidth c01'

      return
c
c write characters
c       symbex is kept for the old MetgraF. In new
c       applications, hchex is preferred.
c
      entry psymbex(x,y,hgt,symb,ang,nsymb)
#ifdef HAS_DRIVER
      if ( lgs ) call ssymbex(x,y,hgt,symb,ang,nsymb)
      if ( .not.lpost ) return
#endif 
      irot=nint(ang)
      ix=isx(x)
      iy=isy(y)
      ihgt=ifs(hgt)
      if ( ihgt.eq.0 ) return 
      if ( ihgt.ne.ihold ) write(lu,'(a4,i3,a5)')'/sf ',ihgt,' def '
      ihold=ihgt
      if ( ang.eq.0.) then
            write(lu,'(a2,a,a2,2i5,2a)') 
     +        ' (',symb(1:nsymb),') ',ix,iy,' Font',curfont(1:lenfon)
      else
             write(lu,'(3i6,a2,a,a,3i5,3a)') 
     +        -ix,-iy,-irot,' (',symb(1:nsymb),') ',
     +        irot,ix,iy,' Font',curfont(1:lenfon),'R'
      endif
      return
                        
      entry ppfill(xc,yc,nc,ncol,nshade)
c
c  ncol   values 1-16
c  nshade values 0-16
c            0 ordinary fill
c            mod(n-1,4)+1  linewidth and shape   _____ |||| 
c            (n-1)/4+1     linetype      _____ --- __-- etc
c fill an area
c
#ifdef HAS_DRIVER
      if ( lgs ) call spfill(xc,yc,nc,ncol,nshade)
      if ( .not.lpost ) return
#endif 
      if ( nshade.lt.0 ) return
      xmin=xc(1)
      xmax=xc(1)
      ymin=yc(1)
      ymax=yc(1)
      if ( ncol.ne.lc ) write (lu,'(a1,i2.2)') 'g',ncol
      write(lu,'(a)') 'newpath'
      write(lu,'(2i5,a)') isx(xc(1)),isy(yc(1)),' M'
      do i=1,nc
            if ( xc(i) .gt. xmax) then
                  xmax=xc(i)
            elseif ( xc(i).lt.xmin) then
                  xmin=xc(i)
            endif
            if ( yc(i) .gt. ymax) then
                  ymax=yc(i)
            elseif ( yc(i).lt.ymin) then
                  ymin=yc(i)
            endif
            write(lu,'(2i5,a)') isx(xc(i)),isy(yc(i)),' L'
      enddo
      if ( xc(nc).ne.xc(1).or.yc(nc).ne.yc(1)) then
            write(lu,'(2i5,a)') isx(xc(1)),isy(yc(1)),' L'
      endif
      write(lu,'(a)') 'closepath'
      if (nshade.eq.0) then
            write(lu,'(a)') 'fill'
      else
c
c write the variables used for hashing 
c
            write(lu,'(a,i4,a)') 'clear /xmin ',isx(xmin),' def'
            write(lu,'(a,i4,a)') '/xmax ',isx(xmax),' def'
            write(lu,'(a,i4,a)') '/ymin ',isy(ymin),' def'
            write(lu,'(a,i4,a)') '/ymax ',isy(ymax),' def'
            write(lu,'(a,i4,a)') '/step ',mod(nshade-1,2)+1,' def'
            write(lu,'(a1,i1)')  't',mod((nshade-1)/4,6)+1
            write(lu,'(a12,i1,a)') 'gsave clip h',mod(nshade-1,4)+1,
     +                         ' grestore'
            write(lu,'(f4.1,a)')  float(lw)/2.5,' setlinewidth'
      endif
      if ( ncol.ne.lc.and.lc.gt.0) write (lu,'(a1,i2.2)') 'g',lc

      return
      entry pnewfon(font)
#ifdef HAS_DRIVER
      if ( lgs ) call snewfon(font)
      if ( .not.lpost ) return
#endif 
      lenfon=lenword_h(font)
      curfont=font(1:lenfon)
      return
c
c line thickness and color change
c
      entry pnewpex(ithick,icolor)
#ifdef HAS_DRIVER
      if ( lgs ) call snewpex(ithick,icolor)
      if ( .not.lpost ) return
#endif 
      if ( ithick.eq.lw.and.icolor.eq.lc) return
      lw=ithick
      lc=max(1,icolor)
      write(lu,'(f4.1,a15,i2.2)') float(lw)/2.5,
     1        ' setlinewidth c',mod(lc-1,mcol)+1
      return
c
c line between two points
c
      entry pvectex(x1,y1,x2,y2,jtyp)
#ifdef HAS_DRIVER
      if ( lgs ) call svectex(x1,y1,x2,y2,jtyp)
      if ( .not.lpost ) return
#endif 
      lintyp=mod(jtyp-1,6)+1
      if ( linold.ne.lintyp) write(lu,'(a1,i1)') 't',lintyp
      write(lu,'(4i5,a)') isx(x2),isy(y2),isx(x1),isy(y1),' l'
      linold=lintyp
      return
c
c plot a line with n points
c
      entry plinex(xc,yc,n,jtyp)
#ifdef HAS_DRIVER
      if ( lgs ) call slinex(xc,yc,n,jtyp)
      if ( .not.lpost ) return
#endif 
        
      lintyp=mod(jtyp-1,6)+1
      if ( linold.ne.lintyp ) write(lu,'(a1,i1)') 't',lintyp
      write(lu,'(a,2i5,a)') 'newpath ',isx(xc(1)),isy(yc(1)),' M'
      do i=2,n
            write(lu,'(2i5,a)') isx(xc(i)),isy(yc(i)),' L'
      enddo
      write(lu,'(a)') 'stroke'
      linold=lintyp
      return
c
c close the postscript file
c
      entry pendex
#ifdef HAS_DRIVER
      if ( lgs ) call sendex
      if ( .not.lpost ) return
#endif 
      print*, 'pendex:closing ',psfile
      write(lu,'(a)') '  4.00  4.00 scale    0    0 translate'
      write(lu,'(3a)') 'showpage ',char(10),'/initgraphics'
      close(lu)
#ifndef HAS_DRIVER
       cmd='gs '
       cmd(4:)=psfile
       if ( lgs )  call system(cmd)
#endif 
      end
