c     +---------------------------------------------------------+
c     + subroutine H : observation operator                     +
c     +---------------------------------------------------------+

      subroutine H(idim,jdim,nana,lat_obs,lon_obs,
     +             lat,lon,dlat,dlon,f_fld,f_obs)

      implicit none

      integer idim,jdim
      integer nana
      real    f_fld(idim,jdim)
      real    f_obs(nana),lat_obs(nana),lon_obs(nana)
      real    lat,lon,dlat,dlon

      integer i,j,k
      real x,y,wx,wy
      do k = 1,nana
	 x  = idim/2 + 1 + (lon_obs(k)-lon)/dlon
	 y  = jdim/2 + 1 + (lat_obs(k)-lat)/dlat
	 i  = int(x)
	 j  = int(y)
	 if(i.ge.1 .and. i.lt.idim .and. j.ge.1 .and. j.lt.jdim) then
	    wx = x-i
	    wy = y-j
	    f_obs(k) = (1.-wx)*(1.-wy)*f_fld(i  ,j  ) +
     +                 (1.-wx)*   wy  *f_fld(i  ,j+1) +
     +                    wx  *(1.-wy)*f_fld(i+1,j  ) +
     +                    wx  *   wy  *f_fld(i+1,j+1)
	 else
	    i        = min(i,idim)
	    i        = max(i,1)
	    j        = min(j,jdim)
	    j        = max(j,1)
	    f_obs(k) = f_fld(i,j)
	 endif
      enddo
      return
      end

      subroutine h_ad(idim,jdim,nana,lat_obs,lon_obs,lat,lon, 
     +                dlat,dlon,f_fld_ad,f_obs_ad )
      implicit none
      integer  idim,jdim,nana
      real     dlat,dlon,lat,lon
      real     lat_obs(nana),lon_obs(nana)
      real     f_fld_ad(idim,jdim),f_obs_ad(nana)
      integer i,j,k
      real x,y,wx,wy
      do k = 1,nana
         x  = idim/2+1+(lon_obs(k)-lon)/dlon
         y  = jdim/2+1+(lat_obs(k)-lat)/dlat
         i  = int(x)
         j  = int(y)
         wx = x-i
         wy = y-j
         if(i.ge.1 .and. i.lt.idim .and. j.ge.1 .and. j.lt.jdim) then
            f_fld_ad(i+1,j+1) = f_fld_ad(i+1,j+1)+f_obs_ad(k)*wx*wy
            f_fld_ad(i,j+1) = f_fld_ad(i,j+1)+f_obs_ad(k)*(1.-wx)*wy
            f_fld_ad(i+1,j) = f_fld_ad(i+1,j)+f_obs_ad(k)*wx*(1.-wy)
            f_fld_ad(i,j) = f_fld_ad(i,j)+f_obs_ad(k)*(1.-wx)*(1.-wy)
            f_obs_ad(k) = 0.
         else
            i = min(i,idim)
            i = max(i,1)
            j = min(j,jdim)
            j = max(j,1)
            f_fld_ad(i,j) = f_fld_ad(i,j)+f_obs_ad(k)
            f_obs_ad(k) = 0.
         endif
      enddo
      end


