c     +------------------------------------------------------------+
c     + subroutine dynber: compute dynamical wind-pressure ro*f2/2 +
c     +------------------------------------------------------------+
      subroutine derivf(t,p,u,v,dyn,idim,jdim,lat,clat,dlat)
      implicit none
      integer idim,jdim
      real t(idim,jdim),p(idim,jdim),u(idim,jdim),v(idim,jdim)
      real dyn(idim,jdim)
      real lat,clat,dlat

      integer i,j
      real pi,r,omega,xdist,ydist,flat,f,f2,ro,dpx,dpy

      r  = 287.0
      pi = asin(1.)*2.
      omega = 7.292e-5
      ydist = 0.5*clat

      do j=1,jdim
         flat = lat + (j-(jdim/2+1))*dlat
         xdist = clat*cos(flat*pi/180.)
         f=2*omega*sin(flat*pi/180.)      ! coriolis
      do i=1,idim
         ro=p(i,j)/(r*t(i,j)) 
	 if(j.eq.1) then
            dpy=-(p(i,j+1)-p(i,j))*2.
	 else if (j.eq.jdim) then
            dpy=-(p(i,j)-p(i,j-1))*2.
	 else
            dpy=-(p(i,j+1)-p(i,j-1))
	 endif
	 if(i.eq.1) then
            dpx= (p(i+1,j)-p(i,j))*2.
	 else if(i.eq.idim) then
            dpx= (p(i,j)-p(i-1,j))*2.
	 else
            dpx= (p(i+1,j)-p(i-1,j))
	 endif
         u(i,j)=( 1/(f*ro) ) * ( dpy/ydist)
         v(i,j)=( 1/(f*ro) ) * ( dpx/xdist)
      enddo   
      enddo   

      do j=1,jdim
      do i=1,idim
         ro=100.*p(i,j)/(r*t(i,j)) 
         f2=u(i,j)**2+v(i,j)**2
         dyn(i,j)=0.5*ro*f2
      enddo   
      enddo   


      return
      end
